require 'sketchup.rb'
class Reporter
def getMaterial(component)
  bits = component.definition.entities
   for f in bits 
       if f.typename == "Face"
               materialClass = f.material
		   if(materialClass!=nil)
                  return materialClass.name
               end 
       end
   end
  
   return "Non assignee."

end

def getSubComponents(entityList, level)
   model = Sketchup.active_model
   selection = model.selection	
   check = false
   for c in entityList
     status = selection.contains? c

     if (status || level>1)
       if c.typename == "ComponentInstance"
         check = true		
         compName = c.definition.name
         if (compName.include? "Part:")
           @@partList.add(compName)
           next 
         end

		subList = c.definition.entities
		hasSubComponents = getSubComponents(subList, level+1)
      	if (!hasSubComponents )
               name = " "+(c.definition.name)
               boundingBox = c.bounds
               dims = [ boundingBox.width.to_s,boundingBox.height.to_s,boundingBox.depth.to_s ]
               boardFeet = boundingBox.width * boundingBox.height * boundingBox.depth / 144
			   boardFeet = ((boardFeet * 1000).round).to_f/1000
               layer = " "+(c.layer.name)
               materialClass = c.material
		   if(materialClass==nil)
                  material = getMaterial(c)
               else
                  material = materialClass.name
               end 	
		   
		   if(boundingBox.width >= boundingBox.height && boundingBox.height >= boundingBox.depth)   		
               	@@clist = @@clist.push([name,dims[0],dims[1],dims[2],boardFeet,material])
               elsif(boundingBox.width >= boundingBox.depth && boundingBox.depth >= boundingBox.height)
               	@@clist = @@clist.push([name,dims[0],dims[2],dims[1],boardFeet,material])
               elsif(boundingBox.height >= boundingBox.width && boundingBox.width >= boundingBox.depth)
               	@@clist = @@clist.push([name,dims[1],dims[0],dims[2],boardFeet,material])
               elsif(boundingBox.height >= boundingBox.depth && boundingBox.depth >= boundingBox.width)
               	@@clist = @@clist.push([name,dims[1],dims[2],dims[0],boardFeet,material])
               elsif(boundingBox.depth >= boundingBox.width && boundingBox.width >= boundingBox.height)
               	@@clist = @@clist.push([name,dims[2],dims[0],dims[1],boardFeet,material])
               else
               	@@clist = @@clist.push([name,dims[2],dims[1],dims[0],boardFeet,material])
		   end #if
			
		end

         end
      end
   end
   return check
end
   @@clist = []

def Reporter::detailledcomponents
   @@clist = [] 
   @@partList = PartList.new()    
   model = Sketchup.active_model

   model.start_operation "CutList"
   entities = model.entities
   mname = model.title
   selection = model.selection


   Sketchup::set_status_text(("Generation de la liste en cours..." ), SB_PROMPT)
   Sketchup::set_status_text(" ", SB_VCB_LABEL)
   Sketchup::set_status_text(" ", SB_VCB_VALUE)


   mpath = Dir::pwd
   if mpath == ""
      UI.beep
      UI.messagebox("Enregistrez votre fichier \navant de faire ce rapport !\nListe non generee.")
      return nil
   end

 	reporter = Reporter.new	
   reporter.getSubComponents(entities,1)

   @@clist = @@clist.sort

   if ((not @@clist[0]) && (@@partList.parts.length == 0))
      UI.beep
      UI.messagebox("Pas de composant(s) selectionne(s).\n\nListe non generee.")
      return nil
   end#if

   namecsv = model.path[0,model.path.length - 4] + " - Liste dbit dtaille.csv"
   file = File.new(namecsv,"w")
   file.puts("Composant#Description#Longueur(X)#Largeur(Y)#Epaisseur(Z)#Panneau#Materiau\n") ### title ###
   i = 1
   ii = 1 ###
   ix = ""
   cx = "" ###

   materialList = []
   

   totalBF = 0	
   for c in @@clist
      i = i + 1 if c[0] != cx and cx != ""
      ii = 1 if c[0] != cx
      ix = " "+i.to_s+"-"+ii.to_s
      file.puts(ix+"#"+c[0]+"#"+c[1]+"#"+c[2]+"#"+c[3]+"#"+c[4].to_s+"#"+c[5])
      ii = ii + 1
      cx = c[0]

	totalBF = totalBF + c[4]
	inList = false
	for d in materialList 
	   if(d[0]==c[5])
            d[1] = d[1]+c[4]
            inList = true	
         end
	end

      if(!inList)
         materialList = materialList.push([c[5],c[4]])
      end


   end#for c
   
      file.puts("")
      file.puts("Total Panneau"+"#"+totalBF .to_s)
      file.puts("")
      file.puts("Materiau#Panneau")
	for d in materialList 
         file.puts(d[0]+"#"+d[1].to_s)
	end

      file.puts("")
      file.puts("composant#Nombre")
	  if(@@partList.parts.length > 0)
	    for e in 0..(@@partList.parts.length-1)
          file.puts(" "+@@partList.parts[e]+"#"+@@partList.partCount[e].to_s)         		  
	    end  ###for
      end ###if		


   file.close
   UI.messagebox("Liste detaillee generee dans: \n" + namecsv + "\n")
   model.commit_operation

end#def components

end#class Reporter


class PartList

  def initialize()
    @parts = Array.new
    @partCount = Array.new
  end 

   def parts
     @parts
   end

   def partCount
     @partCount
   end ###def partCount

   def add(inPart)
     index = @parts.index(inPart)
     if(index != nil)
       @partCount[index] = @partCount[index] + 1    
     else
       @parts.push(inPart)
       @partCount.push(1)
     end  ###if   
   end ###def add

end ###Class PartList

